UNIT Html;

INTERFACE

PROCEDURE StartHtml(VAR F:TEXT; Head:STRING);
PROCEDURE EndHtml(VAR F:TEXT);
FUNCTION ToHtml(S:STRING):STRING;
FUNCTION ReplaceVars(S:STRING):STRING;

CONST StartTemplate : STRING = '<html>'#13#10 +
                               ' <head>'#13#10 +
                               '  <title>%t</title>'#13#10 +
                               ' </head>'#13#10 +
                               ' <body>'#13#10;

      EndTemplate : STRING =   ' </body>'#13#10 +
                               '</html>'#13#10;

VAR percent_vars : ARRAY['a'..'z'] OF STRING;

IMPLEMENTATION

FUNCTION ToHtml(S:STRING):STRING;
VAR T:STRING;
    i:INTEGER;
BEGIN
  T:='';
  FOR i:=1 TO Length(S) DO CASE S[i] OF
    '<':T:=T+'&lt;';
    '>':T:=T+'&gt;';
    '&':T:=T+'&amp;';
    '"':T:=T+'&quot;';
    '':T:=T+'&auml;';
    '':T:=T+'&ouml;';
    '':T:=T+'&uuml;';
    '':T:=T+'&Auml;';
    '':T:=T+'&Ouml;';
    '':T:=T+'&Uuml;';
    '':T:=T+'&szlig;';
    '','','','','','','','':T:=T+'/';
    '','','','','','','','','','','','':T:=T+'|';
    '','','','','':T:=T+'-';
    '','','','','':T:=T+'=';
    '','','','','','','','':T:=T+'\';
    '','':T:=T+'+';
    '':T:=T+'<sup>o</sup>';
    '':T:=T+'<sup>2</sup>';
    '':T:=T+'&infin;';
    '':T:=T+'&laquo;';
    '':T:=T+'&raquo;';
    #128..#255:
      Writeln('WARNING: Can''t encode `',S[i],'''');
  ELSE T:=T+S[i];
  END;
  ToHtml:=T;
END;

FUNCTION ReplaceVars(S:STRING):STRING;
VAR i:INTEGER;
    S1:STRING;
BEGIN
  S1:='';
  WHILE TRUE DO BEGIN
    i := Pos('%', S);
    IF i=0 THEN BEGIN
      ReplaceVars := S1 + S;
      Exit;
    END;
    S1 := S1 + Copy(S, 1, i-1);
    Delete(S, 1, i);
    IF S<>'' THEN CASE S[1] OF
      '%': S1 := S1 + '%';
      'a'..'z': S1 := S1 + percent_vars[s[1]];
      '[': BEGIN
        IF (Length(S)<3) OR (S[2]>='z') OR (S[2]<='a') THEN Writeln('WARNING: Error in conditional `%' + S + '''')
        ELSE BEGIN
          i := Pos(']', S);
          IF i=0 THEN Writeln('WARNING: Missing closing `]'' in conditional') ELSE
          IF percent_vars[s[2]]<>'' THEN BEGIN
            Delete(S, i, 1);
            Delete(S, 1, 1);
          END ELSE BEGIN
            Delete(S, 1, i-1);
          END;
        END;
      END;
    ELSE Writeln('WARNING: Unknown variable `%', S[1], '''');
    END;
    Delete(S, 1, 1);
  END;
END;

PROCEDURE StartHtml(VAR F:TEXT; Head:STRING);
BEGIN
  percent_vars['t'] := Head;
  Write(F, ReplaceVars(StartTemplate));
END;

PROCEDURE EndHtml(VAR F:TEXT);
BEGIN
  Write(F, ReplaceVars(EndTemplate));
END;

BEGIN
  FillChar(percent_vars, Sizeof(percent_vars), 0);
END.